library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all; 
use ieee.std_logic_unsigned.all;
use ieee.numeric_std;


 
ENTITY tb_FactorielMem IS
END tb_FactorielMem;
 
ARCHITECTURE behavior OF tb_FactorielMem IS 
 
	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT FactorielMem
	PORT(
		Rst : IN  std_logic;
		Clk : IN  std_logic;
		D_in : IN  std_logic_vector(4 downto 0);
		D_out_Ready : OUT  std_logic;
		D_out : OUT  std_logic_vector(7 downto 0)
		);
	END COMPONENT;
	
	
	--Inputs
	signal Rst : std_logic := '1';
	signal Clk : std_logic := '0';
	signal D_in : std_logic_vector(4 downto 0) := b"00001";
	
	--Outputs
	signal D_out_Ready : std_logic;
	signal D_out : std_logic_vector(7 downto 0);
	
	-- Clock period definitions
	constant Clk_period : time := 10 ns;
	
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
	uut: FactorielMem PORT MAP (
		Rst => Rst,
		Clk => Clk,
		D_in => D_in,
		D_out_Ready => D_out_Ready,
		D_out => D_out
		);
	
	-- Clock process definitions
	Clk_process :process
	begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
	end process;
	
	-- Rst process definitions
	Rst_process :process
	begin
		Rst <= '1';
		wait for Clk_period;
		
		Rst <= '0';
		wait for 200*Clk_period;
	end process;
	
	-- Input Data process definitions
	D_in_process :process 
	begin
		D_in <= D_in+1;	 
		wait for 50*Clk_period;
	end process;
END;
