library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity CountN is
	Generic ( N : positive := 108;
			  M : positive := 5
			);
    Port ( Data_in : in  STD_LOGIC_VECTOR (M-1 downto 0);
		   Rst : in  STD_LOGIC;
		   Clk : in  STD_LOGIC;
		   End_count: out  STD_LOGIC;
		   Count_out : out  STD_LOGIC_VECTOR (M-1 downto 0));
end CountN;

architecture Behavioral of CountN is

signal Count_tmp : STD_LOGIC_VECTOR (M-1 downto 0):=(others =>'0');
signal End_count_tmp : STD_LOGIC:='0';

begin
	
	P_count : process(Rst, Clk)
	begin
		if Rst ='1' then 
				Count_tmp(M-1 downto 1) <=(others =>'0');
				Count_tmp(0) <= '1'; 
		elsif Clk = '1' and Clk'event then 
			Count_tmp <= Count_tmp+1;
			if Count_tmp=Data_in then 
				Count_tmp(M-1 downto 1) <=(others =>'0');
				Count_tmp(0) <= '1';
			end if;
		end if;
	end process;
	Count_out <= Count_tmp;
	
	P_flag : process(Rst, Clk, Count_tmp )
	begin
	
		if Rst ='1' then 
				End_count_tmp <= '0'; 
		elsif Clk = '1' and Clk'event then 
			if Data_in = Count_tmp then 
				End_count_tmp <= '1';
			else
				End_count_tmp <= '0';
			end if;
		end if;
	end process;
	End_count <= End_count_tmp;
	
end Behavioral;

