library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity MulAccN is
	Generic ( N : positive := 108;
			  M : positive := 5
			);
    Port ( Data_in_A : in  STD_LOGIC_VECTOR (M-1 downto 0);
		   Rst : in  STD_LOGIC;
		   Clk : in  STD_LOGIC;
		   Data_out_P: inout  STD_LOGIC_VECTOR (N+M-1 downto 0));
end MulAccN;

architecture Behavioral of MulAccN is

COMPONENT MUL113
PORT(
	a : IN std_logic_vector(M-1 downto 0);
	b : IN std_logic_vector(N-1 downto 0);          
	p : OUT std_logic_vector(N+M-1 downto 0)
	);
END COMPONENT;
	
COMPONENT Z1
PORT(
	Data_in : IN std_logic_vector(N+M-1 downto 0);
	Rst : IN std_logic;
	Clk : IN std_logic;          
	Data_out : OUT std_logic_vector(N-1 downto 0)
	);
END COMPONENT;


signal Mul_p_tmp  : std_logic_vector(N+M-1 downto 0):=x"000000000000000000000000000" & b"00001";
signal Data_a_tmp :  STD_LOGIC_VECTOR(M-1 DOWNTO 0):=b"00001";
signal Data_b_tmp :  STD_LOGIC_VECTOR(N-1 DOWNTO 0):=x"000000000000000000000000001";

signal Data_in_A_tmp :  STD_LOGIC_VECTOR(M-1 DOWNTO 0):=b"00001";

signal Mul0_a_tmp :  STD_LOGIC_VECTOR(M-1 DOWNTO 0):=b"00001";
signal Mul0_b_tmp :  STD_LOGIC_VECTOR(N-1 DOWNTO 0):=x"000000000000000000000000001";
signal Mul0_p_tmp  : std_logic_vector(N+M-1 downto 0):=x"000000000000000000000000000" & b"00001";

signal Mul0_a :  STD_LOGIC_VECTOR(M-1 DOWNTO 0):=b"00001";
signal Mul0_b :  STD_LOGIC_VECTOR(N-1 DOWNTO 0):=x"000000000000000000000000001";
signal Mul0_p  : std_logic_vector(N+M-1 downto 0):=x"000000000000000000000000000" & b"00001";

begin

	MUL0_1 : MUL113
	PORT MAP (
		a => Mul0_a,
		b => Mul0_b,
		p => Mul0_p
	);
	
	Z1_1: Z1 PORT MAP(
		Data_in => Mul0_p_tmp,
		Rst => Rst,
		Clk => Clk,
		Data_out => Mul0_b_tmp
	);

	Mul0_b <= Mul0_b_tmp;
	Data_out_P <= Mul0_p;
	Mul0_a <= Data_in_A;
	Mul0_p_tmp <= Mul0_p;
end Behavioral;







