library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity Z1 is
	Generic ( N : positive := 108;
			  M : positive := 5
			);
    Port ( Data_in : in  STD_LOGIC_VECTOR (N+M-1 downto 0);
		   Rst : in  STD_LOGIC;
		   Clk : in  STD_LOGIC;
		   Data_out: out  STD_LOGIC_VECTOR (N-1 downto 0));
end Z1;

architecture Behavioral of Z1 is

signal Data_in_tmp  : std_logic_vector(N+M-1 downto 0):=x"000000000000000000000000000" & b"00001";

begin
	P_Z1 : process(Rst, Clk)
	begin
		if Rst ='1' then 
			Data_in_tmp <= x"000000000000000000000000000" & b"00001";
		elsif Clk = '1' and Clk'event then 
			Data_in_tmp <= Data_in;
		end if;
	end process;
	Data_out <= Data_in_tmp(N-1 DOWNTO 0);
	
end Behavioral;







